<template>
    <div>
        <div class="row">
            <div class="col s4">
                <div class="card center-align">
                    <div class="card-content red white-text">
                        Nome
                      <h2 class="card-title cursive">{{ player.name }}</h2>
                    </div>
                </div>
            </div>
            <div class="col s4">
                <div class="card center-align">
                    <div class="card-content red white-text">
                        Jogadas
                        <h2 class="card-title cursive">{{ round }} </h2>
                    </div>
                </div>
            </div>
            <div class="col s4">
                <div class="card center-align">
                    <div class="card-content red white-text">
                        Tempo
                        <h2 class="card-title cursive">{{ time }}</h2>
                    </div>
                </div>
            </div>
        </div>
        <div class="game-container">
            <div class="row">
                <div :class="{ 'item-selected': hasSelected(index), 'item-match': isMatch(item.name) }" v-for="(item, index) in gameItems" class="col s3">
                    <div class="card">
                        <div @click="selectItem(index)" class="game-card">
                            <div class="side front">
                                <img src="/images/logo.png" alt="Game Logo">
                            </div>
                            <div class="side back">
                                <img :src="item.image" alt="item.name">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="card center-align">
            <div class="card-content">
                <button @click="restart()" class="btn">Reiniciar jogo</button>
                <a href="#/start" class="btn orange white-text">Mudar nome do jogador</a>
            </div>
        </div>

        <div id="dialog_success" class="modal">
            <div class="modal-content">
                <h4>Parabéns {{ player.name }}</h4>
                <p>Jogo finalizado.</p>
                <p>Você finalizou o jogo com <b>{{ round }}</b> jogadas, em <b>{{ time }}</b> tempo.</p>
            </div>
            <div class="modal-footer grey lighten-2">
                <button @click="restart()" class="modal-action modal-close waves-effect waves-green btn-flat green lighten-2 white-text">Jogar novamete</button>
                <a href="#/rankings" class="modal-action modal-close waves-effect waves-green btn-flat red lighten-1 white-text">Ver Ranking</a>
            </div>
        </div>
    </div>
</template>
<script>
    import moment from 'moment'
    let chronometer = null;

    export default {

        data() {
            return {
                selectedItems:[],
                matchedItems:[],
                gameItems:[],
                player:{
                  'name': ''
                },
                round:0,
                time:moment().minute(0).second(0).format('mm:ss'),
                items:[

                    {
                        'name': 'acer',
                        'image': '/images/acer.png'
                    },
                    {
                        'name': 'adidas',
                        'image': '/images/adidas.png'
                    },
                    {
                        'name': 'amazon',
                        'image': '/images/amazon.png'
                    },
                    {
                        'name': 'samsung',
                        'image': '/images/samsung.png'
                    },
                    {
                        'name': 'apple',
                        'image': '/images/apple.png'
                    },
                    {
                        'name': 'coca-cola',
                        'image': '/images/coca-cola.png'
                    },
                    {
                        'name': 'netflix',
                        'image': '/images/netflix.png'
                    },
                    {
                        'name': 'google',
                        'image': '/images/google.png'
                    },
                    {
                        'name': 'motorola',
                        'image': '/images/motorola.png'
                    },
                    {
                        'name': 'lamborghini',
                        'image': '/images/lamborghini.png'
                    }
                ]
            }
        },

        methods: {

            isMatch(name) {
                return typeof this.matchedItems.filter(item => item == name)[0] !== 'undefined';
            },

            hasSelected(index) {
                let item = this.selectedItems.filter(item => index == item)[0];
                return typeof item !== 'undefined'
            },

            hasMatch(index) {
                let item = this.gameItems[index]
                let match = this.selectedItems.filter(selectedItem => item.name === this.gameItems[selectedItem].name)

                return match.length == 2;
            },

            hasFinish() {
                if (this.matchedItems.length == 10) {
                    this.finishGame()
                }
            },

            finishGame() {
                clearInterval(chronometer)
                Event.fire(`loading-show`,{'type':'spinner', 'text': 'Salvando dados ...'})

                this.saveMatch()
                   .then(response => {
                       setTimeout(() =>{
                           Event.fire(`loading-hide`)
                           $('#dialog_success').modal().modal('open')
                       }, 600)

                   })

            },

            saveMatch() {
                return Vue.http.post('match',{'player_name': this.player.name, 'time': this.time, 'rounds': this.round})
            },

            restart() {
                this.gameItems = this.randomItems()
                this.matchedItems =[]
                this.round =0
                this.selectedItems = []
                clearInterval(chronometer)
                this.time = '00'
            },

            randomItems() {
                let array = this.shuffle(this.items)
                let array1 = this.shuffle(this.items)
                console.log(this.shuffle(array.concat(array1)))
                return this.shuffle(array.concat(array1))
            },

            selectItem(index) {
                const item = this.gameItems[index]
                if (this.time == '00') { chronometer = this.startChronometer() }

                if (this.hasSelected(index) || this.isMatch(item.name) ) {
                    return false;
                }

                if (this.selectedItems.length >= 2) {
                    this.selectedItems.splice(0,1)
                    this.round ++;
                }

                this.selectedItems.push(index)

                if (this.hasMatch(index)) {
                    this.matchedItems.push(this.gameItems[index].name)
                    this.selectedItems = []
                    this.round ++;
                }

                this.hasFinish()
            },

            shuffle(a) {
                for (let i = a.length - 1; i > 0; i--) {
                    const j = Math.floor(Math.random() * (i + 1));
                    [a[i], a[j]] = [a[j], a[i]];
                }
                return a;
            },

            startChronometer() {
               let time = moment().minute(0).second(0);
               this.time = time.add(1,'second').format('mm:ss')

                return setInterval(() => {
                   this.time = time.add(1,'second').format('mm:ss')
               }, 1000)

            },

            retrievePlayerName() {
                let name = sessionStorage.getItem('memory_game_player');
                if (name) {
                    this.player.name = name;
                } else {
                    this.$router.push('start')
                }
            },

            complete() {
                let items = this.items;
                items.map(item => {
                    this.matchedItems.push(item.name)
                })
                this.hasFinish()
            }
        },
        mounted() {
            this.retrievePlayerName()
            this.restart()
        },
        watch: {
            round(value) {
                Event.fire('round', value)
            }
        }
    }
</script>

<style scoped>

    .game-container .card {
        transition: 300ms ease-out;
        transform-style: preserve-3d;
        background: transparent;
        text-align: center;
    }

    .game-card {
        padding: 10px;
        margin-top: 15px;
        height: 80px;
        cursor: pointer;
    }

    .game-card .side img {
        height: 100%;
        margin: auto;
        display: block;
    }

    .side {
        height: 100%;
        width: 100%;
        background: #fff;
        position: absolute;
        top: 0;
        left: 0;
        backface-visibility: hidden;
        overflow: hidden;
        display: flex;
    }

    .side.back {
        transform: rotateY(180deg);
    }

    .side.front {
        background: #eaeaea;
    }

    .side.front img {
        max-height: 52%;
    }

    .item-selected .card {
        transform: rotateY(180deg);
    }

    .item-match .card {
        transform: rotateY(180deg);
    }

    @media (max-width: 500px) {
        .game-card {
            height: 50px;
        }
    }
</style>